/***************************************************************************
                          ksqlanalyzer.h  -  description
                             -------------------
    begin                : Sun Jan 26 13:05:56 CET 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSQLANALYZER_H
#define KSQLANALYZER_H
 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt
#include <qstrlist.h>
#include <qworkspace.h>
#include <qstringlist.h>
#include <qaccel.h>
#include <qsplitter.h>

// include files for KDE
#include <kapp.h>
#include <kmainwindow.h>
#include <kaction.h>
#include <kurl.h>
#include <kprocess.h>
#include <kcombobox.h>

// Own Includes
#include <myappbar.h>
#include "mymessagebox.h"

// forward declaration of the KSqlAnalyzer classes
class KSqlAnalyzerDoc;
class KSqlAnalyzerView;

/**
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
  * @version KDevelop version 1.3 code generation
  */
class KSqlAnalyzerApp : public KMainWindow
{
Q_OBJECT

public:
/** construtor of KSqlAnalyzerApp  */
	KSqlAnalyzerApp();
	~KSqlAnalyzerApp();

	/** opens a file specified by commandline option */
	void openDocumentFile(const KURL& url=0, bool new_conn=TRUE);

protected:
	virtual bool queryClose();
	virtual bool queryExit();
	virtual void saveProperties(KConfig *_cfg);
	virtual void readProperties(KConfig *_cfg);
	virtual bool eventFilter(QObject* object, QEvent* event);
	virtual void closeEvent(QCloseEvent *);

	void createClient(KSqlAnalyzerDoc* doc, bool new_conn);

public slots:
	void dbReceived(QValueList<QStringList> &, const QString & act_dbname="master");

private slots:
	void slotNewConn();
	void slotDisConn();
	void slotDisConnAll();
	void slotFileNew();
	void slotFileOpen();
	void slotFileOpenRecent(const KURL& url);
	void slotFileSave();
	void slotFileSaveAs();
	void slotFileSaveAll();
	void slotFileClose();
	void slotFilePrint();
	void slotFileQuit();
	void slotEditUndo();
	void slotEditCut();
	void slotEditCopy();
	void slotEditPaste();
	void slotEditSearch();
	void slotEditReplace();
	void slotViewToolBar();
	void slotViewStatusBar();
	void slotWindowNewWindow();
	void slotStatusMsg(const QString &text);
	void windowMenuAboutToShow();
	void windowMenuActivated( int id );
	void slotWindowTile();
	void slotWindowCascade();
	void runQuery();
	void parseQuery();
	void stopQuery();
	void windowChanged(QWidget *);

	void changeDB(const QString &);

	void toggleAppBar();
	void loginSucceed();
	void man_dbchange(const QString &);
	void enableQueryTools(bool);
	void enableTextResults();
	void enableGridResults();
	void enableModifiers(bool);

private:
	void saveOptions();
	void readOptions();
	void initActions();
	void initStatusBar();
	void initView();
	void timerEvent(QTimerEvent *te);
	void enableStdActions(bool);

	KConfig *config;
	QWorkspace *pWorkspace;
	QPrinter *printer;
	int untitledCount;
	QList<KSqlAnalyzerDoc> *pDocList;

	KAction* fileConnect;
	KAction* fileDisconnect;
	KAction* fileDisconnectAll;
	KAction* fileNew;
	KAction* fileOpen;
	KRecentFilesAction* fileOpenRecent;
	KAction* fileSave;
	KAction* fileSaveAs;
	KAction* fileSaveAll;
	KAction* fileClose;
	KAction* filePrint;
	KAction* fileQuit;
	KAction* editCut;
	KAction* editCopy;
	KAction* editSearch;
	KAction* editReplace;
	KAction* editPaste;
	KAction* windowNewWindow;
	KAction* windowTile;
	KAction* windowCascade;
	KAction* help;
	KAction *queryRun;
	KAction *queryStop;
	KAction *queryCheck;
	KAction *textResults;
	KAction *gridResults;

	KToggleAction* viewToolBar;
	KToggleAction* viewStatusBar;
	KActionMenu* windowMenu;

	MyAppBar *appBar;
	QString db, last_save_url;
	bool tools_enabled;
};
 
#endif // KSQLANALYZER_H
