//Dialogs

#ifndef _KWDIALOG_H_
#define _KWDIALOG_H_

#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include <qradiobt.h>
#include <qlistbox.h>

#include <kcolorbtn.h>

#include "kwview.h"

class SearchDialog : public QDialog {
    Q_OBJECT
  public:
    SearchDialog(QStrList *searchFor, QStrList *replaceWith,
      int flags, QWidget *parent, const char *name = 0L);
    void setSearchText( const QString &searchstr );
    const char *getSearchFor();
    const char *getReplaceWith();
    int getFlags();
  protected slots:
    void okSlot();

  protected:
    QComboBox *search;
    QComboBox *replace;

    QCheckBox *opt1;
    QCheckBox *opt2;
    QCheckBox *opt3;
    QCheckBox *opt4;
    QCheckBox *opt5;
    QCheckBox *opt6;
};

class ReplacePrompt : public QDialog {
    Q_OBJECT
  public:
    ReplacePrompt(QWidget *parent, const char *name = 0);
  signals:
    void clicked();
  protected slots:
    void no();
    void all();
    virtual void done(int);
  protected:
    void closeEvent(QCloseEvent *);
};

class GotoLineDialog : public QDialog {
    Q_OBJECT
  public:
    GotoLineDialog(int line, QWidget *parent, const char *name = 0);
    int getLine();
  protected:
    QLineEdit *e1;
};


#endif //_KWDIALOG_H_

