/***************************************************************************
                          logindialog.h  -  description
                             -------------------
    begin                : Sun Jan 26 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOGINDIALOG_H
#define LOGINDIALOG_H

// KDE-Includes
#include <kapplication.h>
#include <klocale.h>
#include <klineedit.h>

// QT-Includes
#include <qwidget.h>
#include <qdialog.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qframe.h>
#include <qpixmap.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qcombobox.h>
#include <kconfig.h>

/**
  *@author Frank von Daak
  */

class LoginDialog : public QDialog  {
   Q_OBJECT
public: 
	LoginDialog(QWidget *parent=0, const char *name=0, bool modal=true);
	~LoginDialog();

private:
	bool cp;
	QComboBox *serverLine;
	KLineEdit *loginLine, *passLine;
	QPushButton *okBut, *cancelBut, *helpBut;
	KConfig *config;
	QString server[1024], user[1024];
	int cnt;

	void closeEvent(QCloseEvent *);
	void keyPressEvent(QKeyEvent *);
	void getRecentLogins();
	void saveLogin();

private slots:
	void cancelPressed();
	void okPressed();
	void changeLogin(int);

signals:
	void login_data(QString, QString, QString);
	void canceled();
};

#endif
