/***************************************************************************
                          myappbar.h  -  description
                             -------------------
    begin                : Thu Feb 13 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYAPPBAR_H
#define MYAPPBAR_H

#include <qapplication.h>
#include <qwidget.h>
#include <qframe.h>
#include <qvbox.h>
#include <qcombobox.h>
#include <qtabwidget.h>
#include <qiconset.h>
#include <qheader.h>
#include <qstringlist.h>
#include <qcursor.h>

#include <klocale.h>

#include "tsqlcont.h"
#include "objectview.h"

/**
  *@author Frank von Daak
  */

class MyAppBar : public QFrame  {
   Q_OBJECT
public: 
	MyAppBar(QWidget *parent=0, const char *name=0);
	~MyAppBar();

	void setDbNames(QStringList);

public slots:
	void setServerInfo(const QString &, const QString &, const QString &, int);

private:
	void resizeEvent(QResizeEvent *re);
	void initObjects();
	void initTemplates();

	int c_count;

	TSQLCont *tsql;
	QString server[1024], login[1024], pass[1024], act_db;
	QStringList dbnames[1024];
	int port[1024];
	bool rows_received, vdep, dbl_conn;

	// Common Objects (Descr., Name of Function, Parameters)
	QString cObjects[13][50][10];
	QString tObjects[13][12][2];

	QVBox *box;
	QComboBox *objectBox;
	QTabWidget *tabWidg;
	ObjectView *objectWidg, *templateWidg;
	QListViewItem *activeItem;
	QString tabChildName[7];

private slots:
	void buildList(int);
	void getFurther(QListViewItem *);
	void insertQueryResults(QValueList<QStringList> &);
	void insertQueryColumns(int, QStringList &);
	void queryReady(int, int);
	void refreshView();
};

#endif
