/***************************************************************************
                          mydataviewer.cpp  -  description
                             -------------------
    begin                : Fri Mar 21 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mydataviewer.h"

MyDataViewer::MyDataViewer(QWidget *parent, const char *name, bool modal )
							: QDialog(parent,name, modal)
{
	binViewer = new QScrollView(this);
	binViewer->setGeometry(0,0,this->width(), this->height());
	binViewer->hide();
	binCanvas = new QLabel(this);
	binCanvas->setAlignment(AlignCenter);
	binViewer->addChild(binCanvas);

	txtViewer = new QTextEdit(this);
	txtViewer->setReadOnly(TRUE);
	txtViewer->setGeometry(0,0,this->width(), this->height());
	txtViewer->hide();
}

MyDataViewer::~MyDataViewer()
{
}

void MyDataViewer::setText(const QString &txt)
{
	QString tmp = txt;
	tmp.replace("\r\n", "\n");
	tmp.replace("\r", "\n");

	txtViewer->insert(tmp);
	txtViewer->setCursorPosition(0,0);
	txtViewer->show();
}

void MyDataViewer::setPixmap(QPixmap px)
{
	int h, w;

	binCanvas->setPixmap(px);
	h = px.height();
	w = px.width();
	binCanvas->resize(w,h);
	if ( w < 80 )
		w = 80;
	if ( w > 800 )
		w = 800;
	if ( h < 80 )
		h = 80;
	if ( h > 600 )
		h = 600;
	this->resize(w,h);
	binViewer->show();
}

void MyDataViewer::resizeEvent(QResizeEvent *re)
{
	binViewer->resize(this->width(), this->height());
	txtViewer->resize(this->width(), this->height());

	int cx, cy;
	cx = cy = 0;
	if ( binCanvas->width() < binViewer->width() )
		cx = (binViewer->width()-binCanvas->width())/2;
	if ( binCanvas->height() < binViewer->height() )
		cy = (binViewer->height()-binCanvas->height())/2;

	binCanvas->move(cx,cy);
}
