/***************************************************************************
                          myhighlighter.cpp  -  description
                             -------------------
    begin                : Sun Feb 2 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "myhighlighter.h"

MyHighlighter::MyHighlighter(QTextEdit *te)
						: QSyntaxHighlighter(te)
{
	multi_comment = mc_sameline = FALSE;
	mc_startline = mc_endline = -1;
	pText = te;

	mc_start = mc_end = -1;
	para = index = -1;

	find_words[0] = "ABSOLUTE";
	find_words[1] = "EXEC";
	find_words[2] = "OVERLAPS";
	find_words[3] = "ACTION";
	find_words[4] = "EXECUTE";
	find_words[5] = "PAD";
	find_words[6] = "ADA";
	find_words[7] = "EXISTS";
	find_words[8] = "PARTIAL";
	find_words[9] = "ADD";
	find_words[10] = "EXTERNAL";
	find_words[11] = "PASCAL";
	find_words[12] = "ALL";
	find_words[13] = "EXTRACT";
	find_words[14] = "POSITION";
	find_words[15] = "ALLOCATE";
	find_words[16] = "FALSE";
	find_words[17] = "PRECISION";
	find_words[18] = "ALTER";
	find_words[19] = "FETCH";
	find_words[20] = "PREPARE";
	find_words[21] = "AND";
	find_words[22] = "FIRST";
	find_words[23] = "PRESERVE";
	find_words[24] = "ANY";
	find_words[25] = "FLOAT";
	find_words[26] = "PRIMARY";
	find_words[27] = "ARE";
	find_words[28] = "FOR";
	find_words[29] = "PRIOR";
	find_words[30] = "AS";
	find_words[31] = "FOREIGN";
	find_words[32] = "PRIVILEGES";
	find_words[33] = "ASC";
	find_words[34] = "FORTRAN";
	find_words[35] = "PROCEDURE";
	find_words[36] = "ASSERTION";
	find_words[37] = "FOUND";
	find_words[38] = "PUBLIC";
	find_words[39] = "AT";
	find_words[40] = "FROM";
	find_words[41] = "READ";
	find_words[42] = "AUTHORIZATION";
	find_words[43] = "FULL";
	find_words[44] = "REAL";
	find_words[45] = "AVG";
	find_words[46] = "GET";
	find_words[47] = "REFERENCES";
	find_words[48] = "BEGIN";
	find_words[49] = "GLOBAL";
	find_words[50] = "RELATIVE";
	find_words[51] = "BETWEEN";
	find_words[52] = "GO";
	find_words[53] = "RESTRICT";
	find_words[54] = "BIT";
	find_words[55] = "GOTO";
	find_words[56] = "REVOKE";
	find_words[57] = "BIT_LENGTH";
	find_words[58] = "GRANT";
	find_words[59] = "RIGHT";
	find_words[60] = "BOTH";
	find_words[61] = "GROUP";
	find_words[62] = "ROLLBACK";
	find_words[63] = "BY";
	find_words[64] = "HAVING";
	find_words[65] = "ROWS";
	find_words[66] = "CASCADE";
	find_words[67] = "HOUR";
	find_words[68] = "SCHEMA";
	find_words[69] = "CASCADED";
	find_words[70] = "IDENTITY";
	find_words[71] = "SCROLL";
	find_words[72] = "CASE";
	find_words[73] = "IMMEDIATE";
	find_words[74] = "SECOND";
	find_words[75] = "CAST";
	find_words[76] = "IN";
	find_words[77] = "SECTION";
	find_words[78] = "CATALOG";
	find_words[79] = "INCLUDE";
	find_words[80] = "SELECT";
	find_words[81] = "CHAR";
	find_words[82] = "INDEX";
	find_words[83] = "SESSION";
	find_words[84] = "CHAR_LENGTH";
	find_words[85] = "INDICATOR";
	find_words[86] = "SESSION_USER";
	find_words[87] = "CHARACTER";
	find_words[88] = "INITIALLY";
	find_words[89] = "SET";
	find_words[90] = "CHARACTER_LENGTH";
	find_words[91] = "INNER";
	find_words[92] = "SIZE";
	find_words[93] = "CHECK";
	find_words[94] = "INPUT";
	find_words[95] = "SMALLINT";
	find_words[96] = "CLOSE";
	find_words[97] = "INSENSITIVE";
	find_words[98] = "SOME";
	find_words[99] = "COALESCE";
	find_words[100] = "INSERT";
	find_words[101] = "SPACE";
	find_words[102] = "COLLATE";
	find_words[103] = "INT";
	find_words[104] = "SQL";
	find_words[105] = "COLLATION";
	find_words[106] = "INTEGER";
	find_words[107] = "SQLCA";
	find_words[108] = "COLUMN";
	find_words[109] = "INTERSECT";
	find_words[110] = "SQLCODE";
	find_words[111] = "COMMIT";
	find_words[112] = "INTERVAL";
	find_words[113] = "SQLERROR";
	find_words[114] = "CONNECT";
	find_words[115] = "INTO";
	find_words[116] = "SQLSTATE";
	find_words[117] = "CONNECTION";
	find_words[118] = "IS";
	find_words[119] = "SQLWARNING";
	find_words[120] = "CONSTRAINT";
	find_words[121] = "ISOLATION";
	find_words[122] = "SUBSTRING";
	find_words[123] = "CONSTRAINTS";
	find_words[124] = "JOIN";
	find_words[125] = "SUM";
	find_words[126] = "CONTINUE";
	find_words[127] = "KEY";
	find_words[128] = "SYSTEM_USER";
	find_words[129] = "CONVERT";
	find_words[130] = "LANGUAGE";
	find_words[131] = "TABLE";
	find_words[132] = "CORRESPONDING";
	find_words[133] = "LAST";
	find_words[134] = "TEMPORARY";
	find_words[135] = "COUNT";
	find_words[136] = "LEADING";
	find_words[137] = "THEN";
	find_words[138] = "CREATE";
	find_words[139] = "LEFT";
	find_words[140] = "TIME";
	find_words[141] = "CROSS";
	find_words[142] = "LEVEL";
	find_words[143] = "TIMESTAMP";
	find_words[144] = "CURRENT";
	find_words[145] = "LIKE";
	find_words[146] = "TIMEZONE_HOUR";
	find_words[147] = "CURRENT_DATE";
	find_words[148] = "LOCAL";
	find_words[149] = "TIMEZONE_MINUTE";
	find_words[150] = "CURRENT_TIME";
	find_words[151] = "LOWER";
	find_words[152] = "TO";
	find_words[153] = "CURRENT_TIMESTAMP";
	find_words[154] = "MATCH";
	find_words[155] = "TRAILING";
	find_words[156] = "CURRENT_USER";
	find_words[157] = "MAX";
	find_words[158] = "TRANSACTION";
	find_words[159] = "CURSOR";
	find_words[160] = "MIN";
	find_words[161] = "TRANSLATE";
	find_words[162] = "DATE";
	find_words[163] = "MINUTE";
	find_words[164] = "TRANSLATION";
	find_words[165] = "DAY";
	find_words[166] = "MODULE";
	find_words[167] = "TRIM";
	find_words[168] = "DEALLOCATE";
	find_words[169] = "MONTH";
	find_words[170] = "TRUE";
	find_words[171] = "DEC";
	find_words[172] = "NAMES";
	find_words[173] = "UNION";
	find_words[174] = "DECIMAL";
	find_words[175] = "NATIONAL";
	find_words[176] = "UNIQUE";
	find_words[177] = "DECLARE";
	find_words[178] = "NATURAL";
	find_words[179] = "UNKNOWN";
	find_words[180] = "DEFAULT";
	find_words[181] = "NCHAR";
	find_words[182] = "UPDATE";
	find_words[183] = "DEFERRABLE";
	find_words[184] = "NEXT";
	find_words[185] = "UPPER";
	find_words[186] = "DEFERRED";
	find_words[187] = "NO";
	find_words[188] = "USAGE";
	find_words[189] = "DELETE";
	find_words[190] = "NONE";
	find_words[191] = "USER";
	find_words[192] = "DESC";
	find_words[193] = "NOT";
	find_words[194] = "USING";
	find_words[195] = "DESCRIBE";
	find_words[196] = "NULL";
	find_words[197] = "VALUE";
	find_words[198] = "DESCRIPTOR";
	find_words[199] = "NULLIF";
	find_words[200] = "VALUES";
	find_words[201] = "DIAGNOSTICS";
	find_words[202] = "NUMERIC";
	find_words[203] = "VARCHAR";
	find_words[204] = "DISCONNECT";
	find_words[205] = "OCTET_LENGTH";
	find_words[206] = "VARYING";
	find_words[207] = "DISTINCT";
	find_words[208] = "OF";
	find_words[209] = "VIEW";
	find_words[210] = "DOMAIN";
	find_words[211] = "ON";
	find_words[212] = "WHEN";
	find_words[213] = "DOUBLE";
	find_words[214] = "ONLY";
	find_words[215] = "WHENEVER";
	find_words[216] = "DROP";
	find_words[217] = "OPEN";
	find_words[218] = "WHERE";
	find_words[219] = "ELSE";
	find_words[220] = "OPTION";
	find_words[221] = "WITH";
	find_words[222] = "END";
	find_words[223] = "OR";
	find_words[224] = "WORK";
	find_words[225] = "END-EXEC";
	find_words[226] = "ORDER";
	find_words[227] = "WRITE";
	find_words[228] = "ESCAPE";
	find_words[229] = "OUTER";
	find_words[230] = "YEAR";
	find_words[231] = "EXCEPT";
	find_words[232] = "OUTPUT";
	find_words[233] = "ZONE";
	find_words[234] = "EXCEPTION";
	find_words[235] = "USE";
}

MyHighlighter::~MyHighlighter()
{
}

int MyHighlighter::highlightParagraph(const QString &text,int endStateOfLastPara)
{
	QString fw_tmp, tmp;
	QChar before, after;
	int pos = - 1;
	int pos2 = -1;

	setFormat(-1, text.length()+2, "black");

	// Highlighting of reserved Keywords START
	for ( int p=0 ; p < 236 ; p++ ) {
		pos = 0;
		fw_tmp = find_words[p];
		while ( (pos = text.find(fw_tmp, pos, false)) > -1 ) {
			before = text.at(pos-1);
			after = text.at(pos+fw_tmp.length());
			if ( pos == 0 ) {
				if ( after.isSpace() || after == "(" || after == ")" ) {
					setFormat(pos, fw_tmp.length(), "blue");
				}
			} else {
				if ( (before.isSpace() || before == "(" || before == ")" )
					&& ( after.isSpace() || after == "(" || after == ")" ) ) {
					setFormat(pos, fw_tmp.length(), "blue");
				}
			}
			pos += fw_tmp.length();
		}
	}
	// Highlighting of reserved Keywords END


	// Highlighting of simple Comments START
	pos = 0;
	if ( (pos = text.find("--", pos, false)) > -1 ) {
		if ( (pos2 = text.findRev("/*", pos,false)) > -1 ) {
			if ( pos2 = text.find("*/", pos2, false) < pos )
				setFormat(pos, text.length(), "darkGray");
		} else
			setFormat(pos, text.length(), "darkGray");
	}
	// Highlighting of simple Comments END



	// Highlighting of multiline Comments (begin) START
	pos = pos2 = 0;
	while ( text.find("/*", pos, false) > -1 ) {
		mc_end = -1;
		if ( (pos = text.find("/*", pos, false)) > -1 ) {
			multi_comment = TRUE;
			mc_start = pos;
			if ( (pos2 = text.find("*/", pos, false)) > -1 ) {
				multi_comment = FALSE;
				mc_end = pos2+2;
			}

			if ( mc_end > -1 ) {
				setFormat(mc_start, mc_end-mc_start, "darkGray");
			} else {
				tmp.sprintf("%d_%d", para, index);
				setFormat(mc_start, text.length()-mc_start, "darkGray");
				mc_startline = para;
			}
			pos += 2;
		}
	}
	// Highlighting of multiline Comments (begin) END


	// Highlighting of multiline Comments (begin) START
	pos = pos2 = 0;
	while ( text.find("*/", pos, false) > -1 ) {
		mc_end = -1;
		if ( ((pos = text.find("*/", pos, false)) > -1) && mc_startline < para ) {
			mc_end = pos + 2;
			setFormat(0, mc_end, "darkGray");
			multi_comment = FALSE;
		}
		pos += 2;
	}
	// Highlighting of multiline Comments (begin) END

	if ( multi_comment && mc_startline < para )
		setFormat(0, text.length(), "darkGray");
}

void MyHighlighter::setCursorPos(int p, int i) {
	para = p;
	index = i;
}