/***************************************************************************
                          mymessagebox.cpp  -  description
                             -------------------
    begin                : Wed Mar 19 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mymessagebox.h"

MyMessageBox::MyMessageBox(const QString &caption, QWidget *parent, const char *name, bool modal )
						: QDialog(parent,name, modal)
{
	this->setCaption(caption);
	this->setFixedSize(350,150);

	QPixmap px = QApplication::style().stylePixmap(QStyle::SP_MessageBoxWarning);
	QLabel *pxFrame = new QLabel(this);
	pxFrame->setPixmap(px);
	pxFrame->setGeometry(10,10,40,60);

	msgLab = new QLabel(this);
	msgLab->setGeometry(60,5,280,90);

	but[0] = new QPushButton(i18n("Yes"), this);
	but[0]->setGeometry(10,120,75,25);

	but[1] = new QPushButton(i18n("No"), this);
	but[1]->setGeometry(95,120,75,25);

	but[2] = new QPushButton(i18n("No to all"), this);
	but[2]->setGeometry(180,120,75,25);

	but[3] = new QPushButton(i18n("Cancel"), this);
	but[3]->setGeometry(265,120,75,25);

	for ( int i=0 ; i < 4 ; i++ )
		connect(but[i], SIGNAL(clicked()), this, SLOT(buttonClicked()));
}

MyMessageBox::~MyMessageBox()
{
}

void MyMessageBox::setMessage(const QString &msg)
{
	msgLab->setText(msg);
}

void MyMessageBox::buttonClicked()
{
	for ( int i=0 ; i < 4 ; i++ ) {
		if ( sender() == but[i] )
			done(i);
	}
}
