/***************************************************************************
                          objectview.cpp  -  description
                             -------------------
    begin                : Mon Feb 24 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "objectview.h"

static const char * pix_file []={
    "16 16 7 1",
    "# c #000000",
    "b c #ffffff",
    "e c #000000",
    "d c #404000",
    "c c #c0c000",
    "a c #ffffc0",
    ". c None",
    "................",
    ".........#......",
    "......#.#a##....",
    ".....#b#bbba##..",
    "....#b#bbbabbb#.",
    "...#b#bba##bb#..",
    "..#b#abb#bb##...",
    ".#a#aab#bbbab##.",
    "#a#aaa#bcbbbbbb#",
    "#ccdc#bcbbcbbb#.",
    ".##c#bcbbcabb#..",
    "...#acbacbbbe...",
    "..#aaaacaba#....",
    "...##aaaaa#.....",
    ".....##aa#......",
    ".......##......."};

ObjectView::ObjectView(QWidget *parent, const char *name )
					: QListView(parent,name)
{
	setAcceptDrops( FALSE );
	viewport()->setAcceptDrops( FALSE );
	initPopup();
}

ObjectView::~ObjectView()
{
}

void ObjectView::contentsDropEvent( QDropEvent *e )
{
	QListView::contentsDropEvent(e);
}

void ObjectView::contentsMousePressEvent( QMouseEvent* e )
{
	if ( e->button() == RightButton )
		pop->popup(e->globalPos());
	else {
		presspos = e->pos();
		QListView::contentsMousePressEvent(e);
		mousePressed = TRUE;
	}
}

void ObjectView::contentsMouseMoveEvent( QMouseEvent* e )
{
	if ( mousePressed && ( presspos - e->pos() ).manhattanLength() > QApplication::startDragDistance() ) {
		QListViewItem *item = itemAt( contentsToViewport(presspos) );
		if ( item ) {
			if ( item->dragEnabled() ) {
				QString source = item->text(4);
				QTextDrag* ud = new QTextDrag(viewport());
				if ( ud ) {
					ud->setText(source);
					ud->setPixmap(QPixmap(pix_file));
					ud->dragCopy();
				}
			}
		}
		mousePressed = FALSE;
	}
	QListView::contentsMouseMoveEvent(e);
}

void ObjectView::contentsMouseReleaseEvent( QMouseEvent* e )
{
	mousePressed = FALSE;
	presspos = QPoint(0,0);
	QListView::contentsMouseReleaseEvent(e);
}

void ObjectView::initPopup()
{
	pop = new KPopupMenu(this);
	pop->insertItem(i18n("Refresh"), this, SLOT(sendRefresh()));
}

void ObjectView::sendRefresh()
{
debug("senditaway...");
	QTimer::singleShot(200, this, SIGNAL(refresh()));
}
