/***************************************************************************
                          objectview.h  -  description
                             -------------------
    begin                : Mon Feb 24 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OBJECTVIEW_H
#define OBJECTVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qlistview.h>
#include <qpoint.h>
#include <qdragobject.h>
#include <qheader.h>
#include <qtimer.h>

#include <klocale.h>
#include <kpopupmenu.h>

/**
  *@author Frank von Daak
  */

class ObjectView : public QListView  {
   Q_OBJECT
public: 
	ObjectView(QWidget *parent=0, const char *name=0);
	~ObjectView();

private slots:
	void sendRefresh();

private:
	void contentsMousePressEvent( QMouseEvent *);
	void contentsMouseMoveEvent( QMouseEvent *);
	void contentsMouseReleaseEvent( QMouseEvent *);
	void contentsDropEvent( QDropEvent * );
	void initPopup();

	QPoint presspos;
	bool mousePressed;
	KPopupMenu *pop;

signals:
	void refresh();
};

#endif
