/***************************************************************************
                          tsqlcont.h  -  description
                             -------------------
    begin                : Sat Feb 1 2003
    copyright            : (C) 2003 by Frank von Daak
    email                : frank.fun@kpage.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TSQLCONT_H
#define TSQLCONT_H


// Non-KDE/QT-Includes
#include <stdio.h>
#include <string.h>
extern "C"
{
#include "tds/tds.h"
#include "tds/tdsconvert.h"
#include "tds/tdsutil.h"
}

// QT-Includes
#include <qobject.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qdatetime.h>
#include <qapplication.h>

#include <qwidget.h>
#include <qpicture.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qlabel.h>

// KDE-Includes
#include <klocale.h>

/**
  *@author Frank von Daak
  */

class TSQLCont : public QObject {
 Q_OBJECT

public: 
	TSQLCont();
	~TSQLCont();

	// Public functions
	/*
	 * tsql_login:
	 * Used for the Login to database.
	 * Returns 'TRUE', if everything is find, else 'FALSE'
	*/
	bool tsql_login(const QString &servername, int port, const QString &username, const QString &password);

	/*
	 * tsql_connect:
	 * Tries to open a connection with the specified settings.
	*/
	bool tsql_connect();

	/*
	 * tsql_doQuery:
	 * Run a submitted query
	*/
	bool tsql_doQuery(const QString &);
	bool break_run;
	int getData(const QString &, QPixmap *);

private:
	// Variables
	TDSLOGIN *login;
	TDSCONTEXT *context;
	TDSMSGINFO *msg;
	TDSSOCKET *tds;
	bool login_ok, breaked;
	QString old_msg, old_err;

	// Functions
	void timerEvent(QTimerEvent *);
	QString sql_err;
	QString sql_msg;


signals:
	void tsql_fatal(const QString &);
	void tsql_error(const QString &);
	void tsql_message(const QString &);

	void tsql_querycolumns_received(int, QStringList &);
	void tsql_tableinfo_received(QStringList &);
	void tsql_queryrow_received(QValueList<QStringList> &);
	void tsql_queryReady(int rows, int time);
	void tsql_dbchange(const QString &);
};

#endif
